Блог пользователя wish_me

Автор wish_me, история, 7 лет назад, По-английски

Can any one explain the topic and also tell me the list of some good problems.Thanks in advance.

  • Проголосовать: нравится
  • -5
  • Проголосовать: не нравится

»
4 года назад, # |
  Проголосовать: нравится +19 Проголосовать: не нравится

Another way to think about multiple sources that's potentially nicer to code is to add a fake source with edges to all the real sources, then BFS as normal, then subtract 1 from all the distances.

  • »
    »
    3 года назад, # ^ |
      Проголосовать: нравится 0 Проголосовать: не нравится

    can you please elaborate what are you trying to tell ?

    • »
      »
      »
      3 года назад, # ^ |
        Проголосовать: нравится +6 Проголосовать: не нравится

      Imagine this is your original graph (not including the red node/edges), and A, B, C are your multiple sources. We can create an additional node X and the red edges shown, then do a standard BFS starting from X. Finally, all the distances will be 1 more than they should be, because you had the extra hop from X to the real source at the beginning of each path.

    • »
      »
      »
      3 года назад, # ^ |
        Проголосовать: нравится +5 Проголосовать: не нравится
      • Instead of pushing all the real sources into the queue, you add a fake source, link it to all the real sources, and just push that single fake source into the queue.
      • If you do the BFS, it will take the fake source out of the queue first, and then it will push all the real sources into the queue right after (because you link the real sources directly to the fake source, they will be the closest to the fake source, which means they should be in the queue after the fake source is visited).
      • Now, all the real sources are inside the queue, as expected. The side effect is that the calculated distances are all +1 compared to the actual distances, that's because the fake source and the fake edges increase the distance. So, subtract 1 from all the distances, and you are good to go.
      • »
        »
        »
        »
        3 года назад, # ^ |
          Проголосовать: нравится 0 Проголосовать: не нравится

        Sir, how does it affects the time complexity? does it make any difference at all.

        • »
          »
          »
          »
          »
          3 года назад, # ^ |
          Rev. 2   Проголосовать: нравится +5 Проголосовать: не нравится

          I think there should be no huge differences. As our red coder said above, it's just nicer to code, as traditionally, you start with a single vertex only.

          If I misunderstand anything, please tell me.

»
4 года назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

Another Problem: 986A - Fair

Add all the nodes you want to BFS from into the initial queue and run it.

»
23 месяца назад, # |
  Проголосовать: нравится +11 Проголосовать: не нравится

I love this community. Thanks for various approaches on multi source BFS.

»
19 месяцев назад, # |
Rev. 2   Проголосовать: нравится 0 Проголосовать: не нравится

This is a nice problem illustrating the use of multiple source BFS: Monsters

»
8 месяцев назад, # |
  Проголосовать: нравится 0 Проголосовать: не нравится

You should do "monsters" problem on cses.